﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Microsoft.SqlServer.Server;

namespace cv05
{
    public partial class Form1 : Form
    {
        private Bitmap bmp;
        private Font font = new Font("Arial", 18);
        private Color fontColor = Color.Black;
        private Color color = Color.Black;

        private Point previous;
        private bool painting;

        public Form1()
        {
            InitializeComponent();

            //Kreslime na bitmapu do pameti
            bmp = new Bitmap(pictureBox.Width, pictureBox.Height);
            using (var g = Graphics.FromImage(bmp))
            {
                g.Clear(Color.White);
            }
            timer1.Enabled = true;
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void panel1_MouseUp(object sender, MouseEventArgs e)
        {
            if (rb_drawLine.Checked)
            {
                painting = false;
            }
        }

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            if (rb_drawLine.Checked)
            {
                painting = true;
                previous = new Point(e.X, e.Y);
            }
            if (rb_drawString.Checked)
            {
                using (var brush = new SolidBrush(fontColor))
                using (var g = Graphics.FromImage(bmp))
                {
                    g.DrawString("String", font, brush, new Point(e.X, e.Y));
                }
            }
        }

        private void panel1_MouseMove(object sender, MouseEventArgs e)
        {
            //Vypis pozice mysi do StatusStripu
            l_statusPosition.Text = $"[{e.X}, {e.Y}]";

            if (rb_drawLine.Checked)
            {
                if (painting)
                {
                    using (var pen = new Pen(color))
                    using (var g = Graphics.FromImage(bmp))
                    {
                        g.DrawLine(pen, previous, new Point(e.X, e.Y));
                    }
                    previous = new Point(e.X, e.Y);
                }
            }
        }

        //Obnoveni pictureBoxu
        private void timer1_Tick(object sender, EventArgs e)
        {
            pictureBox.Image = bmp;
        }

        private void fontToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Vyber fontu
            if (fontDialog1.ShowDialog() == DialogResult.OK)
            {
                font.Dispose();
                font = fontDialog1.Font;
                fontColor = fontDialog1.Color;
            }
        }

        private void colorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Vyber barvy
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                color = colorDialog1.Color;
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Ulozeni
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                bmp.Save(saveFileDialog1.FileName);
            }
        }

        private void loadToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Nacteni
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                using (var loadedImage = new Bitmap(openFileDialog1.FileName))
                using (var g = Graphics.FromImage(bmp))
                {
                    g.Clear(Color.White);
                    g.DrawImage(loadedImage, Point.Empty);
                }
            }
        }

        //Musim ulkidit zdroje, aby nedoslo k memory leaku
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            font.Dispose();
            bmp.Dispose();
        }
    }
}
